This is the readme file for ImageCraft JumpStart C for Cortex-M

Make sure you subscribe to the icc-cortex mailing list for program 
update announcements. To subscribe, send email to 
icc-cortex-subscribe@yahoogroups.com

CHANGE LOGS:
V8.17.00 - 2016/05/03
  CodeBlocks IDE
  - Added "JumpStart API F4xx Project template" from the New->Project wizard
  - Renamed "JumpStart MicroBox" template as "JumpStart API F0xx Project template"
  - Activated unused toolbar icons for building and downloading program to the
    target
  
  Debugger
  - IDBE-CTX - 8.01.00
    = Step out of function method was leaving a system breakpoint set.
    = C::B - Incorrect parameter sent to debugger when using the properties of a 
      watched array.
  - DebugBar-CTX - 8.2.8
    = Fixed exception when trying to debug a project that was just created and 
      had no extra code added to "main"

  ST-LINK Driver/Flash Programming Support
  - Version V1.6.0
  - Revamped internal architecture. Should be faster, more stable, and easier
    to add new device support

  JumpStart API
  - (F0xx) Added jsapi_clock.SetMCO() 
  - (F4xx) Added jsapi_clock.SetMCO1() and .SetMCO2() functions to enable the MCO
    on output pins
  - (F4xx) Added Async I2C routines. NOTE: YOU MUST USE THE NEW STM32F4_VECTORS.S
    in c:\iccv8cortex\libsrc.cortex\ that has the proper interrupt handlers.
  - (F4xx) Added SetReadFilter to USART async API
  - Fixed I2C routines for better performance

  Libraries and Linker
  - Fixed CRC calculation error. FYI - the CRC used is CRC (Modbus)

  Examples.wifi2go
  - Added c:\iccv8cortex\examples.wifi2go


V8.16.01 - 2016/03/10
  JumpStart API
  - Fixed bugs with STM32F0xx JSAPI Timer interrupt functions
  - Fixed bugs with specifying a too low speed for SPI causes random
    SPI speed instead of the slowest possible rate (both STM32F0xx
    and STMF4xx versions)

  JumpStart Debugger
  - Fixed array and other display issues

V8.16.00 - 2016/02/22
  [ M4F/M7 FPU instructions are now supported. See CodeBlocks IDE entry]

  CodeBlocks IDE
  - "Help->Check for ImageCraft Updates" command enhancement
  - Now check for updates on http://imagecraft.com
  - Log files and .ini files are now in <user>\%appdata%\ImageCraftCB\
  - Added "Build Options->Compiler" structure alignment options
  - Added FPU instructions support. To use, enable the checkbox
    [ ] Enable FPU Unit
    in the "Build Options->Target". When enabled, the FP library functions
    will use the FP instructions. A future enhancement will add native
    FP code generation support.

  DebugBAR 
  - Added support for the same hotkeys as main IDE
  - Added support for memory view editing

  Compiler
  - Fixed a "compare zero" elimination optimization bug where if you assign 3 or 
    more variables in a row and then test them in simple conditional tests, the
    compiler sometimes skipped the last test.
  - Fixed a very rare register spilling bug where if you have very complex 
    expression, incorrect value might be used. 

  JumpStart API
  - Added NanoExec, a simple preemptive multitasking executive. See the
    file c:\iccv8cortex\include\nanoexec.h for usage info. 
    To use, use stm32f4_nanoexec_vectors.s for your vector file, as described above, 
    and add "nanoexec" (without the quotes) to your 
    "Project->Build Options->Target->Additional Lib" edit box - multiple libraries 
    (e.g. jsapi-stmf4) can be separated by space

  - Fixed bugs with STM32F4 JSAPI Timer interrupt functions. (F0xx version still
    broken except for TIMER1)

  - Fixed bug with HSE+BYPASS for F0xx/F4xx


V8.15.00 - 2016/01/17
  CodeBlocks IDE
  - Added Help->"Check for ImageCraft Updates" to check for updates
   
  Compiler
  - Fixed a long existing (rare) bug where if a parameter to a function is 
    used only inside a loop, its lifetime might not be computed correctly
    and bad code might be generated

  Libraries
  - Added time.h functions. The user must initialize the timer state and 
    invoke a periodic update function. See time.h for details
  - Added 64-bit double FP trig and other functions in math.h (PRO license
    only)
  - Added stdlib.h qsort and bsearch functions. Currently qsort does not
    work on Cortex M0

  JumpStart API
  - Fixed bug with using HSE->PLL on F030

  ST-LINK LLDE (v1.5.0)
  - bug fixes and improvements

  JumpStart Debugger (IDBE_1.00.065, and DebugBar_CTX 2.0.2.2)
  - Misc. enhancements

V8.14.00 - 2015/12/08
  CodeBlocks IDE
  - Fixed issues with paths with spaces introduced by CB V13/10542 integration 
    (8.13.00)

  JumpStart Debugger (IDBE_1.00.064)
  - DebugBar V2 - All views now dock to DebugBar or float on the desktop.

V8.13.02 - 2015/12/03
  CodeBlocks IDE
  (issues introduced with CB V13/10542 integration introduced in 8.13.00)
  - Fixed path issues when opening existing projects
  - Fixed problem with "File->New->Project"

  JumpStart Debugger
  - Added IO View support for STM32F05x, W108, L4x6, and L15x

V8.13.00 - 2015/11/23
  CodeBlocks IDE
  - Upgraded to CB version 13 branch 10542
  - Fixed issues with breakpoint handling
  - Added initial support for Internationalization

  Linker
  - Fixed a bug with incorrectly diagnosing anonymous structs as
    having different type signatures when Cross Module Type Checking
    is on

  JumpStart API
  - Added JSAPI_SPI::WriteByteArray() and JSAPI_SPI::WriteWordArray()

V8.12.05 - 2015/11/09
  Compiler
  - Fixed __packed issue with nested structure member

  JumpStart API
  - Added support for STM32F4xx. All example projects for the JumpStart
    MicroBox now works on the STM32F401 (Timer API not yet completed)

  JumpStart Debugger (IDBE_CTX_1.00.063)
  - Fixed step-in and runToAddress issues
  - Fixed stack trace issues with Cortex M3/M4
  - Miscellaneous DebugBar (1.0.1.22) fixes and enhancements

  Examples
  - Moved to use stm32f0_vectors.s for F030 projects
  - Added examples.C-Tutorials projects

  Vendor Libraries
  - Added c:\iccv8cortex\VendorLibs\ST-StdPeriphLib\ source. Contains V1 
    and V2 of ST lib

V8.12.04 - 2015/10/25
  Compiler
  - Fixed a linker speed issue - link time should improve by 25%-75%

  STLINK-DLL
  - updated to V1.4.0.0.g. Mainly to fix erase and programming for 
    STM32L1, STM32F1xx targets

V8.12.03 - 2015/10/18
  Installer was using the registry key "JumpStart C for...", which is
  inconsistent with the compiler tools usage. Changed back to 
  "ICCV8 for..."

  JumpStart API
  - Added c:\iccv8cortex\libsrc.cortex\jsapi\ACEShield for the source 
    code to the ACE Shield JumpStart API. There is no plan to release the
    source code to the low level JumpStart API yet.

  - JSAPI_GPIO was not setting the PUSHPULL / OPENDRAIN attribute
    correctly

  JumpStart Debugger (internal ID: IDBE_1.00.058)
  - Fixed a number of bugs   

  - Changed licensing: limited functionality (2 breakpoints, 2 watchpoints,
    DebugBar enables CPU, Code and Memory tabs only) if there is no 
    JDB license and outside of the 45 day demo period.

  - Added debugBar support for full list of STM32F030xx, F042x, F427x. 
    F437x, F439x, F446x

V8.12.02 - 2015/10/14
  CodeBlocks IDE
  - New->Project using templates were broken

V8.12.01 - 2015/10/09
  JumpStart API
  - Added interrupt driven code to USART. See jsapi.h and web doc
    for details

  JumpStart Examples 
  (c:\iccv8cortex\examples.JumpStartMicroBox\default.workspace)
  - update cortex-vectors_m0.s to add interrupt entries for USART

V8.12.00 - 2015/09/28
  JDB-CTX Debugger
  - Numerous usability enhancements

  Major release to support the JumpStart API, JumpStart MicroBox etc.

v8.11.03 - 2015/07/07
  CodeBlocks IDE
  - Fixed problem with CB generating different link order for project files

  Compiler
  - Cortex-M0 only: sometimes the compiler generated incorrect code for
    var_x *= <constant>

    and other similar commutative operators.

  Header File
  stdlib.h
  - CHANGED itoa/ltoa/utoa/ultoa prototype to be compatible with other
    compilers:

    // base can be 2 to 36
    char *ltoa(long, char *, int);
    char *itoa(int, char *, int);
    char *ultoa(unsigned long, char *, int);
    char *utoa(unsigned, char *, int);

    (We wrote these functions BEFORE they were popular with other
    compilers and hence the prototypes were different)

    You might enable the old form prototype by defining the macro
    OLD_STYLE_ITOA in the Project->Build Options->Compiler macro
    define box.

    Added a new "#pragma prototype_changed.." to warn of this situation.

  Libraries
  - Added cortex-M0_vectors.s and cortex-M3_vectors.s to 
    <install root>\libsrc.cortex

    They contain dummy entries for the IRQ tables (32 for M0 and 240 for
    M3)

V8.11.02 - 2015/05/12
  Compiler
  - "#pragma ignore_unused_var ..." was not working for arguments to a
    function
  - The order or arguments to a function flipped from left to right to
    right to left. This has no effect on well-behaved C Standard 
    conforming programs. Done for the benefits of M0 code generation
    where the number of usable registers is limited.

  JDB-Cortex
  - Miscellaneous fixes

  ST-LINK Support
  - Added support for STM32F070/STM32F4xx devices

V8.11.01 - 2015/04/03
  CodeBlocks IDE  
  - Added the feature to save a project including the source files to a 
    zip file (File->Save Project To Archive)
  - Started infrastructure for Internationalization support

  Compiler / Debugger
  - Added Cortex-M0 support. 

  JSAPI (JumpStart API)
  - Beta release for the STMF030. See examples under 
    C:\iccv8cortex\examples.cortex\JSAPI\STM32F030\Test
    (also an example on using the Cortex-M0 STM32F030)

v8.11.00 - 2015/03/05
  Changed installer / icons / splash pages / etc. to rebrand as
  "JumpStarter C for Cortex"

  CodeBlocks IDE
  - Added Autoversioning plugin. To use 
    "Project->AutoVersioning", then accept to autoversion the project. 
    Click Help button for help.
  - "ImageCraft->Create Makefile" was not handling asm .s files correctly.

  JDB-CTX Debugger
  - Fixed an issue where "reset target" sometimes did not work correctly.
  - Fixed problems with project in a directory with spaces in the name.

  ST-LINK
  - Added support for STM32F030

  Compiler
  - Enabled C++ typedef redefinition
  - Enabled interspersed declarations and statements, and for loop 
    variable declaration, two C99/C++ features
  - (BETA) Enabled "C with Classes", subset of C++ features that allow
    member functions within struct definition.
  - __inline is now case insensitive
  - set structure alignment to 4 bytes instead of 2 - this is required
    for M0 and also better performance for M3/M4.

  Linker
  - Fixed a rare problem when "mov32" pseudo-instruction is used (this
    is used for loading a 32-bit constant only when the function body is
    too large) and the referenced address is located in the absolute
    memory address with the non-zero high 16 bits, e.g.

      #pragma ram_abs_address:0x20001000
      struct x x;
      #pragma end_abs_address
      ...
      foo(&x);

  Library
  - Added %h (short) and %hh (byte) modifiers to printf 

V8.10.00 - 2014/01/05
  IDE
  - Preliminary Cortex-M0 suppport. Not fully tested on hardware devices
    although some testing have been done and this passed all our own 
    validation tests under simulator.

  JDB Debugger
  - Added IO View support for Nordic Semiconductor nRF51422 and nRF51822
    and STM M0 devices

  Compiler
  - Initializing an "unsigned long long" global variable was causing the
    compiler to assert

  - Added support for C++ style typedef:
      typedef struct x y;
      ...

      typedef struct x {
        int junk;
      }y;

    This is used by the Nordic Semiconductor BLE stack source code

  Examples.CorStarter
  - Now includes the classic Adventure game! Set the baud rate to 9600 and
    be sure to use the P9 FTDI-USB connecotr. You need to use a terminal
    program and you may need to tweak how CR and LF in the getchar()/putchar()
    routines, depending on your terminal program.

V8.09.01 - 2014/09/19
  IDE
  - Updated list of supported devices

  Compiler
  - Compiler was incorrectly generating blne/bleq for the IT instruction 
    blocks

  - struct/union elements were packed to 4 bytes when they should be packed
    to 2 bytes for compatibility with hardware IO structure expectation.

  - The compiler was generating incorrect code if the 4th argument to a
    function is a "long long" variable.

  Debugger
  - float variables were displayed incorrectly
  - added capability to change the radix and data type of a variable in
    the watch window
  - added support for IO register view (PRO only) for NXP LPC devices. The 
    complete list of supported devices is (also available in the file 
    <install root>\bin\idb\advanced_ioview_targets.txt)   
    
    NXP: LPC175x, LPC176x, LPC178x
    ST: STM32F100xx, STM32F101xx, STM32F102xx, STM32F103xx, STM32F105xx
        STM32F107xx, STM32w108  

  Assembler
  - Fixed incorrect encoding for some of the LDRSB/LDRB/LDRSH/LDRH 
    instructions with shift operands.

  Flash downloader
  - icc_flash.exe is renamed to iflash-cortex.exe for better naming 
    compatibility with flash downloader for AVR.

V8.09.00 - 2014/08/22
  [ Upgraded to the latest protection engine for Win8 compatibility ]
  IDE
  - Added "File->Import project..." commands to add Keil MDK, and IAR
    project files.
  - Freescale Kinetis devices require 0x400 bytes to be skipped for the
    interrupt vectors instead of 0x200 for all other Cortex-M devices.

  IDE Debugger
  - Fixed an issue with setting data type with respect to watch points
  - New splash screen when the Debugger window comes up.

  Driver (icccortex.exe)
  - When -MM0 is used, automatically add "-D_CORTEX_M0" to the C 
    Preprocessor.

  Compiler (iccomcortex.exe)
  - __weak attribute is parsed and ignored with a warning message emitted.

  Assembler (iascortex.exe)
  - Fixed bugs in the branch lengthening logic where it was asserting
    under some conditions.
  - Improved branch lengthening logic such that larger files would see
    1% o 2% smaller object code output by more optimial use of 16-bit 
    short branches.

V8.08.00 - 2014/04/07
  IDB DEBUGGER
  - [ PRO only ] Added support for viewing IO Registers in the debugger. 
    Not all devices are supported. We will add them as fast as we can.

  - [ PRO only ] Added support for mixed mode display in the "DebugBar"

  CB IDE
  - Automatically close the map and list files when you do a build since
    it renders the files out of date.

  - Fixed "Save Project As Template..."

  - "Project->Build Options->Paths" now use relative paths (relative to
    the project dir) if possible.

  - The STM32F105 entries had incorrect SRAM size (should be 64K)

  - Change the project name in the Project->Properties dialog box now
    works correctly.

  Compiler
  - Fixed bug with function arguments with % operations not working
    correctly.

  - Under some circumstances, the compiler generated incorrect debug
    line information.

  Assembler
  - The assembler might fail with assertion error under some conditions.

  Debugger and Flash Loader
  - ST-LINK/V2 support: added support for STM32F10x/L15x/L162 devices.

V8.07.02 - 2014/01/23
  CB/IDB
  - Improved error reporting regarding JTAG pod usage
  IDB
  - Fixed debugger crashing when watching a large data array object
  - Fixed some crashing issues with ST-LINK support

V8.07.01 - 2014/01/06
  CodeBlocks IDE and IDB
  - Fixed some crashing issues

  ST-LINK/V2 support
  - Added support for L152, e.g. STM L-Dsicvoery kits

  Compiler
  - 64-bits FP are now fully tested 

  Documentation
  - Added sections on reset and interrupt handling, programming the STM32
    peripherals etc. to the "Programming the Cortex M" chapter.

  Libraries
  - Removed stub vectors, SystemInit, etc.

  Examples 
  - Fixed errors
  - Changed examples.corstarter to use ST-LINK/V2 as the default pod

V8.07.00 - 2013/12/26
  Installer
  - Added DotNET 4 Web client profile dependency for DebugBar

  CodeBlocks IDE
  - Fixed some issues related to debugging

  C Preprocessor
  - Added
      #pragma once
    specifies that this file should only be processed once by the C
    preprocessor, even if it is #include multiple times.

  Compiler
  - Fixed a number of 64-bit long long defects

  ST-LINK/V2 support
  - Added the driver directory c:\iccv8cortex\ST-LINK_USB_VS_Driver.
  - Added support to F105RC

  Assembler/Linker
  - Eliminated 64K code limit of a single object file.

  Startup Code and Libraries
  - Eliminated the call to SystemInit() from the startup code and the default
    empty SystemInit() from the libraries

  Examples
  - Added CorStarter Examples c:\iccv8cortex\examples.Corstarter-stm32
  - Fixed SystemInit() issues with ST examples

V8.06.02 - 2013/11/16
  IDE
  - Fixed links to new Help files
  - Fixed issues with ST-LINK/V2 

V8.06.01 - 2013/11/07
  IDB/CodeBlocks
  - Enabled DebugBar, a new GUI for debugging.

V8.06.00 - 2013/11/05
  Help File
  - Changed to use Adobe Technical Communications 4 and made various
    content improvements.

  CodeBlocks IDE
  - For Freescale devices, add 0x410 as the flash offset to accomodate the 
    config registers
  - Fixed a bug with File->SaveAs...
  - Added File->SaveProjectAs...
  - Fixed defects with makefile generation (ImageCraft->Create Makefile)

  IDE/Debugger
  - Added to "Project->Build Options->Debugger" the ability to select the
    JTAG Pod (Segger Jlink or ST-LINK/V2) and JTAG vs. SWD interface.
  - Added options to icc_flash.exe to support the ST-LINK/V2

  Compiler
  - Added __forceregister storage class modifier. Should only be used on
    function parameters, particularly static inline function using asm()
    statements, e.g.

        static __inline unsigned __REV(__forceregister unsigned val)
            {
            asm("REV %val,%val");
            return val;
            }

  - Changed compiler so that it would not remove volatile read, e.g.

      extern volatile unsigned int i;
      ...
      i;   // used to be elided

8.05.02 - 2013/08/24
  IDE
  - Removed CMSIS Config Wizard as it is not very useful.

  Header File
  - Added bitband.h, see the file for complete description
    // 'a' is the address, e.g. &GPIOC->BRR, or &external_var
    // 'b' is the bit number and must be between 0 and 31 (inclusive)

    _BITBAND_CLEAR(a, b)
    _BITBAND_SET(a, b)
    _BITBAND_TOGGLE(a, b)
    _BITBAND_READ(a, b)

  Compiler
  - 8.05.01 was emitting incorrect structure size in the debug data. Fixed.
  - Eliminated unnecessary line number entries in debug data,
  - Fixed a rare bug with mixed mode arithmetic optimization.

  Libraries
  - Enabled using of libfpcortex.a and liblpcortex.a for different PRINTF versions.
    (Project->Build Options->Target->Printf)

8.05.01 - 2013/07/05
  Added "Device" name to the .mp map file. If you are working on an existing
    project, you must invoke the Build Options and then click OK for this new
    feature to appear in the map file.

  Debugger
  - Compiler did not generate correct debug info for local / param 
    variables (introduced in 8.05.00)
  CodeBlocks IDE
  - NXP LPC SRAM size was incorrectly reduced by half. This was necessary
    prior to using the Segger derived memory information file. Not needed
    any more.

    (If you are working on existing NXP projects, you must invoke the Build 
     Options and then click OK for this fix to take effect.)

8.05.00 - 2013/06/25
  - Added full versions of ftoa (printf %f/%g/%e). The default is the fast 
    and smaller version. The fast version cannot handle certain values 
	outside of a range. See comments in stdlib.h or Help file for details.

	To use, add 
	  ftoa-full-cortex

	to Project->BuildOptions->Target->"Extra Libraries" box

    We will add a GUI checkbox later.
  IDB Debugger
  - Added "Reset Target" command and toolbar button
  - Fixed miscellaneous bugs
  Compiler
  - Under PRO license, enabled removal of static inline functions if all
    uses are inlined.
  - Under PRO license, removed static functions if there is no code in
    the function.
  - Fixed bugs with inline codegen support
  - Fixed miscellaneous bugs
  Assembler
  - Added MSR/MRS, LDREX?/STREX? instructions
  - Fixed not assembling "ldr Rx,[Ry]" bug
  - Fixed "LDR Rx,LIT+..." issues
  Header File
  - Use CMSIS V3 header files from ARM
  - Added Cortex instruction intrinsics to core_cmInstr.h
  Listing File (.lst file)
  - Improved LITERAL pools handling
  Libraries
  - revamped ftoa()
  - added full version of ftoa
  Examples
  - Added FreeRTOS port and demo for STM32

8.04.00  - April 29, 2013
  [ STD / NC / DEMO now have a limit of 128K. EXPIRED DEMO is 32K ]
  IDB Debugger
  - Watch and Disassembly windows were broken in 8.03.01
  - Fixed problem with incorrect dongle license handling
  Compiler
  - Added support for __inline. This eases porting of examples for other
    compilers.
  Dongle Driver
  - V2 license dongle driver
  Examples
  - Added EFM32 LED Blinking program

8.03.01  - Mar 18, 2013
  IDB Debugger
  - Fixed some crash issues with project path with spaces and other issues.
  - Fixed stepping in / out issues.

  Compiler
  - Added support for __packed, it must precede the "struct" or "union"
    keyword. When present, then all the elements of the aggregate is packed
	with alignment holes. This slows down the access, but could be important 
	when you are writing protocol firmware.

  ICC_Flasher.exe
  - Fixed issue with not resetting the target correctly on some devices.

  Header Files
  - Added TI LM header files

  Examples
  - Restructued STM32 example to be cleaner

8.03.00 Dec4th, 2012
  First IDB (ImageCraft Debugger) release. IDB is fully integrated with the 
  CB IDE. Supports Segger JLINK emulators,
  - Fully functional under the PRO license. It will automatically download 
    the project output.
  - With DEMO/-NC/STD licenses, the debugger is limited to a single 
    breakpoint and up to 64K code code.
  - With expired demo, the debugger is not functional.

  Enabled dongle license

  Compiler
  - bug fixes and feature enhancements

8.01.00 Sept 19, 2012
  CodeBlocks IDE
  - Started integration with the Segger JLink. Added icc_flash.exe to Tools->
    "Flash Utility for Segger." If a Segger Jlink pod is attached, this will
    program the output of the current project based on the selected device.
  - Added Tools->Generate Makefile 

  Compilers
  - Some bug fixes

8.00.00 August 24th, 2012
  - Open c:\iccv8cortex\examples.cortex\examples.workspace for some sample 
    projects
 
  - ARM CMSIS header files under c:\iccv8cortex\include\CMSIS, the compiler
    driver automatically includes this directory (along with
    c:\iccv8cortex\include\) in the search list.

  - NXP header files under c:\iccv8cortex\include\<vendor name>\
    You will have to explicitly add them to the Include Path, e.g.
       $(TARGET_COMPILER_DIR)NXP\LPC17xx\

  - No vendor CMSIS source files are included as they are rather large. 
    Please download them from the vendors' sites.

  - Please refer to the documentation, "Programming for Cortex-M" on what
    steps to take to get a working project.

